"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const controller_1 = require("@curveball/controller");
const privilegeService = require("../../privilege/service");
const hal = require("../formats/hal");
const userService = require("../service");
const groupService = require("../../group/service");
class UserByHrefController extends controller_1.default {
    async get(ctx) {
        const user = await userService.findByHref(decodeURIComponent(ctx.params.href));
        let hasControl = false;
        let hasPassword = false;
        const isAdmin = await privilegeService.hasPrivilege(ctx, 'admin');
        if (ctx.state.user.id === user.id) {
            hasControl = true;
        }
        else if (isAdmin) {
            hasControl = true;
        }
        if (hasControl && user.type === 'user') {
            hasPassword = await userService.hasPassword(user);
        }
        ctx.response.body = hal.item(user, await privilegeService.getPrivilegesForPrincipal(user), hasControl, hasPassword, isAdmin, await groupService.findGroupsForPrincipal(user));
    }
}
exports.default = new UserByHrefController();
//# sourceMappingURL=by-href.js.map